SystemOrganization addCategory: #ConfigurationOfPathTools!

Object subclass: #ConfigurationOfPathTools
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfPathTools'!

!ConfigurationOfPathTools class methodsFor: 'development support' stamp: 'tfel 7/5/2011 15:44:05.038'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfPathTools class methodsFor: 'private' stamp: 'tfel 7/5/2011 15:44:05.075'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfPathTools class methodsFor: 'private' stamp: 'tfel 7/5/2011 15:44:05.094'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfPathTools class methodsFor: 'private' stamp: 'mp 7/18/2013 10:58:42.49'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemtalksystems.com/ss/metacello/' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfPathTools class methodsFor: 'metacello tool support' stamp: 'tfel 7/5/2011 15:44:05.131'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfPathTools class methodsFor: 'loading' stamp: 'tfel 7/5/2011 15:44:05.149'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfPathTools class methodsFor: 'loading' stamp: 'tfel 3/6/2012 15:41:41.328'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load: #('Dev')! !

!ConfigurationOfPathTools class methodsFor: 'loading' stamp: 'tfel 7/5/2011 15:44:05.186'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfPathTools class methodsFor: 'repositories' stamp: 'tfel 3/6/2012 15:14:02.127'!
pathTools

	^ 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/PathTools/'! !

!ConfigurationOfPathTools class methodsFor: 'accessing' stamp: 'tfel 7/5/2011 15:44:05.204'!
project

	^self new project! !

!ConfigurationOfPathTools class methodsFor: 'repositories' stamp: 'tfel 3/6/2012 15:15:55.707'!
swaUtilities

	^ 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/SwaUtilities/'! !

!ConfigurationOfPathTools class methodsFor: 'development support' stamp: 'tfel 7/5/2011 15:44:05.056'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfPathTools methodsFor: 'baselines' stamp: 'tfel 7/5/2011 17:20:30.699'!
baseline10: spec
	<version: '1.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		
		spec project: 'Connectors' with: [
				spec
					className: 'ConfigurationOfConnectors';
					file: 'ConfigurationOfConnectors';
					repository: 'http://www.squeaksource.com/MetacelloRepository';
					versionString: '1.0' ].
		
		spec repository: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/masterproject2011'.
		spec
			package: 'SwaUtil';
			package: 'MethodWrappers';
			package: 'SSpec' with: [spec requires: #('SwaUtil' 'MethodWrappers')];
			package: 'Animations';
			package: 'TypeHarvesting' with: [spec requires: #('SwaUtil')];
			package: 'SwaMC' with: [spec requires: #('SwaUtil')];
			package: 'SightL' with: [spec requires: #('Connectors' 'SwaMC' 'SwaUtil' 'SSpec' 'Animations' 'TypeHarvesting')].
		spec group: 'default' with: #('SightL') ].
! !

!ConfigurationOfPathTools methodsFor: 'baselines' stamp: 'ag 1/23/2012 10:03:12.954'!
baseline13: spec
	<version: '1.3-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		
		spec project: 'Connectors' with: [
				spec
					className: 'ConfigurationOfConnectors';
					file: 'ConfigurationOfConnectors';
					repository: 'http://www.squeaksource.com/MetacelloRepository';
					versionString: '1.0' ].
		
		spec repository: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/masterproject2011'.
		spec
			package: 'SwaUtil';
			package: 'Icons';
			package: 'MethodWrappers';
			package: 'SSpec' with: [spec requires: #('SwaUtil' 'MethodWrappers')];
			package: 'Animations';
			package: 'TypeHarvesting' with: [spec requires: #('SwaUtil')];
			package: 'SwaMC' with: [spec requires: #('SwaUtil')];
			package: 'SightL' with: [
				spec requires: #('Connectors' 'SwaMC' 'SwaUtil' 'SSpec' 'Animations' 'TypeHarvesting').
				spec postLoadDoIt: #postLoadSightL].
		spec group: 'default' with: #('SightL') ].
! !

!ConfigurationOfPathTools methodsFor: 'baselines' stamp: 'tfel 2/14/2012 16:00:34.185'!
baseline14: spec
	<version: '1.4-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		
		spec project: 'Connectors' with: [
				spec
					className: 'ConfigurationOfConnectors';
					file: 'ConfigurationOfConnectors';
					repository: 'http://www.squeaksource.com/MetacelloRepository';
					versionString: '1.0' ].
				
		spec project: 'SpellingServices' with: [
				spec
					className: 'ConfigurationOfSpellingServices';
					file: 'ConfigurationOfSpellingServices';
					repository: 'http://www.squeaksource.com/MetacelloRepository';
					versionString: '1.0' ].
		
		#('SwaUtil' 'MethodWrappers' 'Animations' 'Icons') do: [:package |
			spec package: package with: [
				spec repository: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/SwaUtilities']].
		
		"spec package: 'SightL' with: [
			spec
				repository: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/CodeSight'
				username: (UIManager default
								request: 'Username for CodeSight repository')
				password: (UIManager default
								requestPassword: 'Password for CodeSight repository');
				requires: #('Connectors' 'SwaMC' 'SwaUtil' 'SSpec' 'Animations' 'Icons');
				postLoadDoIt: #postLoadSightL]."

		spec repository: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/masterproject2011'.
		spec
			package: 'SSpec' with: [spec requires: #('SwaUtil' 'MethodWrappers')];
			package: 'SwaMC' with: [spec requires: #('SwaUtil')];
			package: 'SightL' with: [
				spec
					requires: #('Connectors' 'SwaMC' 'SwaUtil' 'SSpec'
								'MethodWrappers' 'Animations' 'Icons' 'SpellingServices');
					postLoadDoIt: #postLoadSightL].

		spec group: 'default' with: #('SightL') ].
! !

!ConfigurationOfPathTools methodsFor: 'baselines' stamp: 'tfel 4/11/2012 14:05'!
baseline15: spec
	<version: '1.5-baseline'>
	| repo username password |
	spec for: #'common' do: [
		spec blessing: #'baseline'.
		
		spec project: 'Connectors' with: [
			spec
				className: 'ConfigurationOfConnectors';
				file: 'ConfigurationOfConnectors';
				repository: 'http://www.squeaksource.com/MetacelloRepository';
				versionString: '1.0.1' ].
				
		spec project: 'SpellingServices' with: [
			spec
				className: 'ConfigurationOfSpellingServices';
				file: 'ConfigurationOfSpellingServices';
				repository: 'http://www.squeaksource.com/MetacelloRepository';
				versionString: '1.0.1' ].

	spec package: 'SwaUtil' with: [spec repository: self class swaUtilities].
	spec package: 'MethodWrappers' with: [spec repository: self class swaUtilities].
	spec package: 'Animations' with: [spec repository: self class swaUtilities].
	spec package: 'Icons' with: [spec repository: self class swaUtilities].

	spec package: 'SwaMC' with: [
		spec
			requires: #('SwaUtil');
			repository: self class swaUtilities].

	spec package: 'SSpec' with: [
		spec
			requires: #('SwaUtil' 'MethodWrappers');
			repository: self class swaUtilities].
		
	repo := MCRepositoryGroup default repositories
				detect: [:r | (r respondsTo: #locationWithTrailingSlash) and: [
							r locationWithTrailingSlash = self class pathTools]]
				ifNone: [].
	username := (repo ifNotNil: [repo user] ifNil: [''])
					ifEmpty: [UIManager default request: 'PathTools repository username'].
	password := (repo ifNotNil: [repo password ifNil: ['']])
					ifEmpty: [UIManager default requestPassword: 'PathTools repo password'].

	spec repository: self class pathTools username: username password: password.
	
	spec package: 'Path-Core' with: [
		spec requires: #('SwaUtil' 'MethodWrappers' 'Animations' 'Icons')].
	spec package: 'Path-Dev' with: [spec requires: #('Path-Core' 'Path-Map' 'Path-Finder' 'Path-View')].
	spec package: 'Path-Harvester' with: [spec requires: #('Path-Core' 'SpellingServices')].
	spec package: 'Path-Finder' with: [spec requires: #('Path-Core')].
	spec package: 'Path-Map' with: [spec requires: #('Path-Finder' 'Path-Harvester')].
	spec package: 'Path-Spike' with: [spec requires: #('Path-Core')].
	spec package: 'Path-View' with: [
		spec
			requires: #('Connectors' 'Path-Core' 'Path-Map' 'Path-Harvester' 'SwaMC' 'SSpec');
			postLoadDoIt: #postLoadConnectorsArrows].
	spec package: 'Path-Tests' with: [
		spec requires: #('Path-Core' 'Path-Dev' 'Path-Harvester' 'Path-Finder' 'Path-Map'
						'Path-Spike' 'Path-View')].
					
	spec group: 'PathTools' with: #('Path-Finder' 'Path-Map' 'Path-View').
	spec group: 'Dev' with: #('PathTools' 'Path-Tests' 'Path-Spike' 'Path-Dev').
	spec group: 'default' with: #('PathTools')].
! !

!ConfigurationOfPathTools methodsFor: 'baselines' stamp: 'mp 6/7/2013 14:55:15.943'!
baseline16: spec
	<version: '1.6-baseline'>
	| repo username password |
	spec for: #'common' do: [
		spec blessing: #'baseline'.

		spec project: 'Connectors' with: [
			spec
				className: 'ConfigurationOfConnectors';
				file: 'ConfigurationOfConnectors';
				repository: 'http://www.squeaksource.com/MetacelloRepository';
				versionString: '1.0.1' ].
					
		spec project: 'SpellingServices' with: [
			spec
				className: 'ConfigurationOfSpellingServices';
				file: 'ConfigurationOfSpellingServices';
				repository: 'http://www.squeaksource.com/MetacelloRepository';
				versionString: '1.0.1' ].

		spec project: 'RefactoringBrowser' with: [
			spec
				className: 'ConfigurationOfRefactoringBrowser';
				file: 'ConfigurationOfRefactoringBrowser';
				repository: 'http://www.squeaksource.com/MetacelloRepository';
				versionString: '1.6' ].			

	spec package: 'SwaUtil' with: [spec repository: self class swaUtilities].
	spec package: 'MethodWrappers' with: [spec repository: self class swaUtilities].
	spec package: 'Animations' with: [spec repository: self class swaUtilities].
	spec package: 'Icons' with: [spec repository: self class swaUtilities].

	spec package: 'SwaMC' with: [
		spec
			requires: #('SwaUtil');
			repository: self class swaUtilities].

	spec package: 'SSpec' with: [
		spec
			requires: #('SwaUtil' 'MethodWrappers');
			repository: self class swaUtilities].
		
	repo := MCRepositoryGroup default repositories
				detect: [:r | (r respondsTo: #locationWithTrailingSlash) and: [
							r locationWithTrailingSlash = self class pathTools]]
				ifNone: [].
	username := (repo ifNotNil: [repo user] ifNil: [''])
					ifEmpty: [UIManager default request: 'PathTools repository username'].
	password := (repo ifNotNil: [repo password ifNil: ['']])
					ifEmpty: [UIManager default requestPassword: 'PathTools repo password'].

	spec repository: self class pathTools username: username password: password.
	
	spec package: 'Path-Contracts' with: [spec requires: #('Path-Harvester')].
	spec package: 'Path-Core' with: [spec requires: #('SwaUtil' 
														'MethodWrappers'
														'Animations' 
														'Icons')].
	spec package: 'Path-Dev' with: [spec requires: #('Path-Finder' 
														'Path-Map'
														'Path-View')].
	spec package: 'Path-Finder' with: [spec requires: #('Path-Core')].
	spec package: 'Path-Harvester' with: [spec requires: #('Path-Core' 
															'SpellingServices')].
	spec package: 'Path-Map' with: [spec requires: #('Path-Finder'
														'Path-Contracts')].
	spec package: 'Path-Spike' with: [spec requires: #('Path-Finder' 
														'Path-Map'
														'Path-View')].
	spec package: 'Path-Tests' with: [spec requires: #('Path-Finder' 
														'Path-Map'
														'Path-View'
														'Path-Dev'
														'Path-Spike')].
	spec package: 'Path-View' with: [spec requires: #('Connectors'
														'RefactoringBrowser' 
														'Path-Map' 
														'SwaMC' 
														'SSpec');
											postLoadDoIt: #postLoadConnectorsArrows].													
					
	spec group: 'default' with: #('Path-Core' 'Path-Finder' 'Path-Map' 'Path-View' 'Path-Contracts' 'Path-Harvester' 'Path-Tests' 'Path-Spike' 'Path-Dev')].
! !

!ConfigurationOfPathTools methodsFor: 'symbolic versions' stamp: 'mp 5/28/2013 15:22:55.517'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.6'.
! !

!ConfigurationOfPathTools methodsFor: 'post-load-doIts' stamp: 'tfel 3/5/2012 09:30:55.172'!
postLoadConnectorsArrows

	(Smalltalk at: #NCAAConnectorMorph) withAllSubclassesDo: [ :cl | cl initializeArrowDictionary ].
	(Smalltalk
		at: #SConnector
		ifAbsent: [Smalltalk
					at: #SClassConnector
					ifAbsent: [^ self]]) withAllSubclassesDo: [:class | class initialize].! !

!ConfigurationOfPathTools methodsFor: 'post-load-doIts' stamp: 'tfel 2/14/2012 16:04:38.366'!
postLoadSightL

	self postLoadConnectorsArrows.! !

!ConfigurationOfPathTools methodsFor: 'accessing' stamp: 'tfel 7/5/2011 15:44:05.019'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfPathTools methodsFor: 'symbolic versions' stamp: 'mp 7/18/2013 10:19:34.807'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.6'.
! !

!ConfigurationOfPathTools methodsFor: 'versions' stamp: 'tfel 7/22/2011 10:24:49.639'!
version11: spec
	<version: '1.1' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec description: 'Bump'.
		spec author: 'tfel'.
		spec timestamp: '7/22/2011 10:24'.
		spec project: 'Connectors' with: '1.0.1'.
		spec 
			package: 'SightL' with: 'SightL-tfel.463';
			package: 'MethodWrappers' with: 'MethodWrappers-bs.19';
			package: 'Animations' with: 'Animations-fb.19';
			package: 'SSpec' with: 'SSpec-tfel.4';
			package: 'SwaMC' with: 'SwaMC-tfel.12';
			package: 'SwaUtil' with: 'SwaUtil-TM.59';
			package: 'TypeHarvesting' with: 'TypeHarvesting-tfel.53'. ].
! !

!ConfigurationOfPathTools methodsFor: 'versions' stamp: 'tfel 7/22/2011 12:09:20.764'!
version12: spec
	<version: '1.2' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: ''.
		spec author: 'tfel'.
		spec timestamp: '7/22/2011 12:09'.
		spec project: 'Connectors' with: '1.0.1'.
		spec 
			package: 'SightL' with: 'SightL-tfel.466';
			package: 'MethodWrappers' with: 'MethodWrappers-bs.19';
			package: 'Animations' with: 'Animations-fb.19';
			package: 'SSpec' with: 'SSpec-tfel.4';
			package: 'SwaMC' with: 'SwaMC-tfel.12';
			package: 'SwaUtil' with: 'SwaUtil-TM.59';
			package: 'TypeHarvesting' with: 'TypeHarvesting-tfel.54'. ].
! !

!ConfigurationOfPathTools methodsFor: 'versions' stamp: 'tfel 2/13/2012 13:12:52.552'!
version13: spec
	<version: '1.3' imports: #('1.3-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '1.3 (): update
1.3 (): Added inheritedTestSelectors'.
		spec author: 'ag'.
		spec timestamp: '1/23/2012 10:17'.
		spec project: 'Connectors' with: '1.0.1'.
		spec 
			package: 'Icons' with: 'Icons-mt.1';
			package: 'SightL' with: 'SightL-tfel.565';
			package: 'MethodWrappers' with: 'MethodWrappers-bs.19';
			package: 'Animations' with: 'Animations-fb.19';
			package: 'SSpec' with: 'SSpec-tfel.4';
			package: 'SwaMC' with: 'SwaMC-tfel.12';
			package: 'SwaUtil' with: 'SwaUtil-tfel.60';
			package: 'TypeHarvesting' with: 'TypeHarvesting-ag.106'. ].
! !

!ConfigurationOfPathTools methodsFor: 'versions' stamp: 'tfel 3/6/2012 14:32:47.037'!
version14: spec
	<version: '1.4' imports: #('1.4-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec description: '1.4 (): Merge with upstream changes
1.4 (): test
1.4 (): Move code to Connectors package
1.4 (): More work on automatic graph-layout. Built in some configurable class-side switches, added debug-mode visualizing how the different (nested) subgraphs are positioned.
last release before re-organization'.
		spec author: 'tfel'.
		spec timestamp: '3/6/2012 14:31'.
		spec 
			project: 'Connectors' with: '1.0.1';
			project: 'SpellingServices' with: '1.0.1'.
		spec 
			package: 'Icons' with: 'Icons-mt.1';
			package: 'SightL' with: 'SightL-ag.578';
			package: 'MethodWrappers' with: 'MethodWrappers-mt.20';
			package: 'Animations' with: 'Animations-mt.21';
			package: 'SSpec' with: 'SSpec-tfel.4';
			package: 'SwaMC' with: 'SwaMC-tfel.12';
			package: 'SwaUtil' with: 'SwaUtil-tfel.80'. ].
! !

!ConfigurationOfPathTools methodsFor: 'versions' stamp: 'tfel 3/6/2012 15:30:34.123'!
version15: spec
	<version: '1.5' imports: #('1.5-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: ''.
		spec author: 'tfel'.
		spec timestamp: '3/6/2012 14:31'.
		spec 
			project: 'Connectors' with: '1.0.1';
			project: 'SpellingServices' with: '1.0.1'.
		spec 
			package: 'Icons' with: 'Icons-mt.1';
			package: 'Path-Core' with: 'Path-Core-tfel.2';
			package: 'Path-Dev' with: 'Path-Dev-tfel.1';
			package: 'Path-Finder' with: 'Path-Finder-tfel.1';
			package: 'Path-Harvester' with: 'Path-Harvester-tfel.2';
			package: 'Path-Map' with: 'Path-Map-tfel.1';
			package: 'Path-Spike' with: 'Path-Spike-tfel.1';
			package: 'Path-View' with: 'Path-View-tfel.2';
			package: 'Path-Tests' with: 'Path-Tests-tfel.3';
			package: 'MethodWrappers' with: 'MethodWrappers-mt.20';
			package: 'Animations' with: 'Animations-mt.21';
			package: 'SSpec' with: 'SSpec-tfel.4';
			package: 'SwaMC' with: 'SwaMC-tfel.12';
			package: 'SwaUtil' with: 'SwaUtil-tfel.80'. ].
! !

!ConfigurationOfPathTools methodsFor: 'versions' stamp: 'mp 7/18/2013 10:22:08.935'!
version16: spec
	<version: '1.6' imports: #('1.6-baseline')>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec description: 'Release version for PathMap, PathFinder, PathBrowser, and PathView'.
		spec author: 'mp'.
		spec timestamp: '7/18/2013 10:19'.
		spec 
			project: 'Connectors' with: '1.0.1';
			project: 'SpellingServices' with: '1.0.1'.
		spec 
			package: 'Icons' with: 'Icons-mt.3';
			package: 'Path-Contracts' with: 'Path-Contracts-mp.29';
			package: 'Path-Core' with: 'Path-Core-mp.63';
			package: 'Path-Dev' with: 'Path-Dev-mp.23';
			package: 'Path-Finder' with: 'Path-Finder-mp.24';
			package: 'Path-Harvester' with: 'Path-Harvester-mp.24';
			package: 'Path-Map' with: 'Path-Map-mp.47';
			package: 'Path-Spike' with: 'Path-Spike-mp.7';
			package: 'Path-Tests' with: 'Path-Tests-mp.53';
			package: 'Path-View' with: 'Path-View-mp.137';
			package: 'MethodWrappers' with: 'MethodWrappers-mt.22';
			package: 'Animations' with: 'Animations-mt.26';
			package: 'SSpec' with: 'SSpec-tfel.4';
			package: 'SwaMC' with: 'SwaMC-tfel.12';
			package: 'SwaUtil' with: 'SwaUtil-mp.87'. ].! !
